var LibReg = function()
{
	var libreg = {};
	var debug = 0;
	
	var libCommentsIsValid = false;
	var barcodeTemplateIsValid = false;
	
	// Page initialization
	libreg.initPage = function()
	{		
		// Step 1
		Events.addEventHandler('bioplate', 'change', libreg.bioPlateOnChange);
		Events.addEventHandler('outcomeSuccess', 'click', libreg.outcomeOnChange);
		Events.addEventHandler('outcomeFailed', 'click', libreg.outcomeOnChange);
		Events.addEventHandler('step-1', 'wizard-validate', libreg.validateStep1);
		
		// Step 2
		Events.addEventHandler('step-2', 'wizard-initialize', libreg.initializeStep2);
		Events.addEventHandler('step-2', 'wizard-validate', libreg.validateStep2);
		Events.addEventHandler('hybridizationDate', 'blur', Wizard.validateDate);
		Events.addEventHandler('pcrDate', 'blur', Wizard.validateDate);
		Events.addEventHandler('cleanupDate', 'blur', Wizard.validateDate);
		Events.addEventHandler('libComments', 'blur', libreg.libCommentsOnChange);

		// Navigation
		Buttons.addClickHandler('gocancel', Wizard.cancelWizard);
		Buttons.addClickHandler('gorestart', Wizard.restartWizard);
		Buttons.addClickHandler('gonext', Wizard.goNextOnClick);
		Buttons.addClickHandler('goregister', Wizard.goRegister);
		
		// Final registration
		Events.addEventHandler('wizard', 'wizard-submit', libreg.submit);
		
		var url = '../Mips.servlet?ID='+App.getSessionId();
		url += '&cmd=GetUnprocessedPlates&plateType=MIPS';
		Wizard.showLoadingAnimation('Loading MIPs plates...');
		Wizard.asyncJsonRequest(url, libreg.initializeStep1);
	}


	libreg.initializeStep1 = function(response)
	{
		var frm = document.forms['reggie'];
		var bioplates = response.bioplates;

		var plates = frm.bioplate;
		if (bioplates.length > 0)
		{
			for (var i=0; i < bioplates.length; i++)
			{
				var bioplate = bioplates[i];
				var name = bioplate.name;
				var option = new Option(name, bioplate.id);
				option.bioplate = bioplate;
				plates.options[plates.length] = option;
			}
		}
		else
		{
			Wizard.setFatalError('No MIPs plates available for processing.');
			return;
		}

		libreg.bioPlateOnChange();
		libreg.outcomeOnChange();
		frm.bioplate.focus();

		Doc.show('step-1');
		Doc.show('gonext');
	}
	
	libreg.bioPlateOnChange = function()
	{
		Wizard.setInputStatus('bioplate', 'valid');
	}

	libreg.outcomeOnChange = function()
	{
		var frm = document.forms['reggie'];
		var failed = Doc.element('outcomeFailed').checked
		if (failed)
		{
			Doc.addClass(frm.libComments, 'required');
		}
		else
		{
			Doc.removeClass(frm.libComments, 'required');
		}
	}

	
	libreg.validateStep1 = function(event)
	{}
	
	libreg.initializeStep2 = function()
	{
		var frm = document.forms['reggie'];	

		var failed = Doc.element('outcomeFailed').checked;
		Wizard.setCurrentStep(2);
		if (failed)
		{
			Wizard.showGoNextConfirmation(true, 'Check to verify registration of failure.');
			libreg.libCommentsOnChange();
		}
		
		Doc.show('gocancel');
		Doc.show('goregister');
		
		var plateName = frm.bioplate[frm.bioplate.selectedIndex].bioplate.name;
		
		frm.hybridizationDate.focus();

		// Load Library protocols
		Reggie.loadProtocols('LIBRARY_PROTOCOL', 'libProtocol', 'LIBPREP_TARGET', 'MIPs');

		// Load barcode templates
		var url = '../Mips.servlet?ID='+App.getSessionId() + '&cmd=GetBarcodeTemplates';
		Doc.addClass('barcodeTemplate', 'list-loading');
		frm.barcodeTemplate[0] = new Option('loading...');
		Wizard.asyncJsonRequest(url, libreg.barcodeTemplatesLoaded);

	}
	
	libreg.barcodeTemplatesLoaded = function(response)
	{
		Doc.removeClass('barcodeTemplate', 'list-loading');
		var frm = document.forms['reggie'];
		var templates = response.templates;
	
		frm.barcodeTemplate.length = 0;
		for (var i = 0; i < templates.length; i++)
		{
			var tmp = templates[i];
			var option = new Option(tmp.name, tmp.id);
			frm.barcodeTemplate[frm.barcodeTemplate.length] = option;
		}
		if (frm.barcodeTemplate.length == 0)
		{
			Wizard.setInputStatus('barcodeTemplate', 'invalid', 'No available barcode templates');
			barcodeTemplateIsValid = false;
			return;
		}
		Wizard.setInputStatus('barcodeTemplate', 'valid');
		barcodeTemplateIsValid = true;
	}
	
	libreg.libCommentsOnChange = function()
	{
		var failed = Doc.element('outcomeFailed').checked;
		if (!failed) return;

		var frm = document.forms['reggie'];
		libCommentsIsValid = false;
		Wizard.setInputStatus('libComments');
		
		var comments = frm.libComments.value;
		if (comments == '')
		{
			Wizard.setInputStatus('libComments', 'invalid', 'Missing');
			return;
		}

		Wizard.setInputStatus('libComments', 'valid');
		libCommentsIsValid = true;
	}

	libreg.validateStep2 = function(event)
	{
		var valid = barcodeTemplateIsValid;
		
		valid &= Wizard.isValid('hybridizationDate');
		valid &= Wizard.isValid('pcrDate');
		valid &= Wizard.isValid('cleanupDate');
		
		var failed = Doc.element('outcomeFailed').checked;
		if (failed)
		{
			valid &= libCommentsIsValid;
		}
		if (!valid) event.preventDefault();
	}

	
	libreg.submit = function()
	{
		var frm = document.forms['reggie'];

		var submitInfo = {};
		submitInfo.bioplate = parseInt(frm.bioplate.value, 10);

		var failed = Doc.element('outcomeFailed').checked;
		submitInfo.failed = failed;
			
		submitInfo.hybridizationDate = frm.hybridizationDate.value;
		submitInfo.hybridizationOperator = frm.hybridizationOperator.value;
		submitInfo.pcrDate = frm.pcrDate.value;
		submitInfo.pcrOperator = frm.pcrOperator.value;
		submitInfo.cleanupDate = frm.cleanupDate.value;
		submitInfo.cleanupOperator = frm.cleanupOperator.value;

		submitInfo.barcodeTemplate = parseInt(frm.barcodeTemplate.value, 10);
		submitInfo.libProtocol = parseInt(frm.libProtocol.value, 10);
		submitInfo.libComments = frm.libComments.value;
		
		var	url = '../Mips.servlet?ID='+App.getSessionId();
		url += '&cmd=RegisterLibraryPrep';
		Wizard.showLoadingAnimation('Performing registration...');
		Wizard.asyncJsonRequest(url, libreg.submissionResults, 'POST', JSON.stringify(submitInfo));
	}

	libreg.submissionResults = function(response)
	{
		var frm = document.forms['reggie'];
		Wizard.showFinalMessage(response.messages);
		Doc.show('gorestart');
	}

	return libreg;
}();

Doc.onLoad(LibReg.initPage);

