<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.clients.web.Base"	
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, "net.sf.basedb.reggie", true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.reggie");
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final User user = User.getById(dc, sc.getLoggedInUserId());
%>
<base:page type="default" >
<base:head 
	scripts="~../reggie-2.js,~histology_protocol.js" 
	styles="path.css,~../css/reggie-2.css"
/>
<base:body>

	<p:path><p:pathelement 
		title="Reggie" href="<%="../index.jsp?ID="+ID%>" 
		/><p:pathelement title="Create lab tracking protocol for FFPE/HE" 
		/></p:path>

	<div class="content">

	<form name="reggie" action="histology_protocol2.jsp" method="post" target="_blank" id="wizard" class="wizard">
	<input type="hidden" name="ID" value="<%=ID%>">
	
	<div class="step" id="step-1">
		<div class="step-no">1</div>
		<div class="step-title">Select or create histology work list</div>
		<div class="step-content">

			<table clasS="step-form">
			<tr>
				<td class="prompt">Histology work list</td>
				<td class="input">
					<select name="workList" id="workList" class="required"></select>
				</td>
				<td class="status" id="workList.status"></td>
				<td class="help">
					<span id="workList.message" class="message"></span>
					Select an existing histology work list or choose to create a new one.
				</td>
			</tr>
			<tr>
				<td class="prompt"></td>
				<td class="input">
					<base:buttongroup style="margin-top: 0.5em;">
						<base:button image="new.png" title="Create new work list" id="btnCreateWorkList" />
					</base:buttongroup>
				</td>
				<td class="status"></td>
				<td class="help"></td>
			</tr>
			</table>
		</div>
	</div>
	
	<div id="wizard-status"></div>
	
	<table class="navigation" id="navigation">
	<tr>
		<td><base:button id="gocreate" title="Finish" image="<%=home+"/images/gonext.png"%>" /></td>
		<td id="gonext-message" class="message"></td>
	</tr>
	</table>
	</form>
	</div>
	
</base:body>
</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>