<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.clients.web.Base"	
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="java.text.SimpleDateFormat"
	import="java.util.Date"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, "net.sf.basedb.reggie", true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.reggie");
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final User user = User.getById(dc, sc.getLoggedInUserId());
	final String today = new SimpleDateFormat("yyyy-MM-dd").format(new Date());
%>
<base:page type="default" >
<base:head 
	scripts="~../reggie-2.js,~histology_work_list.js" 
	styles="path.css,~../css/reggie-2.css"
	>
<style>
#numSelected
{
	font-style: italic;
	margin-top: 0.25em;
	margin-left: 1em;
}
</style>
</base:head>
<base:body>

	<p:path><p:pathelement 
		title="Reggie" href="<%="../index.jsp?ID="+ID%>" 
		/><p:pathelement title="Create Histology work list" 
		/></p:path>

	<div class="content">

	<form name="reggie" id="wizard" class="wizard">
	<input type="hidden" name="ID" value="<%=ID%>">
	
	<div class="step" id="step-1">
		<div class="step-no">1</div>
		<div class="step-title">Create histology work list</div>
		<div class="step-content">

			<table class="step-form">
			<tr>
				<td class="prompt">Histology work list</td>
				<td class="input">
					<input type="text" class="required" name="name" id="name" 
						value="Histology work list <%=today%>" maxlength="255">
				</td>
				<td class="status" id="name.status"></td>
				<td class="help">
					<span id="name.message" class="message"></span>
					Give the list a name.
				</td>
			</tr>
			<tr class="align-top">
				<td class="prompt">Comments</td>
				<td class="input">
					<textarea name="comments" id="comments" rows="2">Work list for keeping track of a batch of samples to be embedded in paraffin blocks.</textarea>
				</td>
				<td class="status" id="comments.status"></td>
				<td class="help">
					<span id="comments.message" class="message"></span>
				</td>
			</tr>
			<tr class="align-top">
				<td class="prompt">Histology items</td>
				<td class="input">
					<select	name="histology" id="histology" multiple="multiple" size="30"></select>
					<div id="numSelected"></div>
					
					<base:buttongroup style="margin-top: 0.5em;">
						<base:button title="Select manually&hellip;" id="btnSelectHistologyItems" />
					</base:buttongroup>
				</td>
				<td class="status" id="histology.status"></td>
				<td class="help">
					<span id="histology.message" class="message"></span>
					The list contain Histology items (max 100) that has not been embedded in paraffin blocks 
					(determined by absence of a 'creation' date). Selection must be made in blocks of 5.
				</td>
			</tr>
			</table>
		</div>
	</div>
	
	<div id="wizard-status"></div>
	
	<table class="navigation" id="navigation">
	<tr>
		<td><base:button id="gocancel" title="Cancel" /></td>
		<td><base:button id="gonext" title="Next" image="<%=home+"/images/gonext.png"%>" /></td>
		<td><base:button id="goregister" title="Register" image="<%=home+"/images/import.png"%>"  /></td>
		<td><base:button id="gorestart" title="Restart" image="<%=home+"/images/goback.png"%>" /></td>
		<td><base:button id="goprotocol" title="Show protocol" image="<%=home+"/images/gonext.png"%>" /></td>
		<td id="gonext-message" class="message"></td>
	</tr>
	</table>
	</form>

	<form name="print" action="histology_protocol2.jsp?ID=<%=ID%>" method="post" target="_blank">
		<input type="hidden" name="workList" value="">
	</form>

	</div>
	
</base:body>
</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>